# select and delete element from DLL

# as initial configurations, we take a set of all possible DLLs
#
# - z:3 points to the head of the list

# pointer variables are : x=1, y=2, z=3
# next pointers are : next=0 back=1 

def get_program():
	program=[
		("goto","0000000",8,"NOABSTR"),
		("exit","1100000"), 
		("exit","1100000"), 
		("exit","1100000"), 
		("exit","1100000"), 
		("exit","1100000"), 
		("exit","1100000"), 
		("exit","1100000"), 
	
		("x=y","0001000",1,3,9,"NOABSTR"), 
		("x=null","0001001",2,10,"NOABSTR"),
		("if*","0001010",11,14), 
		("x=y","0001011",2,1,12,"NOABSTR"),
		("x=y.next","0001100",1,1,0,13,"NOABSTR"),
		("ifx==null","0001101",1,31,10,"NOABSTR"),
		("ifx==y","0100001",1,3,15,18,"NOABSTR"),
		("x=y.next","0100010",3,3,0,16,"NOABSTR"),
		("ifx==null","0101000",3,22,17,"NOABSTR"),
		("x.next=null","0100011",3,1,22,"NOABSTR"),
		("x=y.next","0100100",1,1,0,19,"NOABSTR"),
		("x.next=y","0100101",2,1,0,20,4),
		("ifx==null","0100110",1,22,21,"NOABSTR"),
		("x.next=y","0100111",1,2,1,22,5),
		("ifx==null","0101001",3,31,23,"NOABSTR"),
		("x=y.next","0010100",1,3,1,24,"NOABSTR"),
		("ifx==null","0010101",1,25,30,"NOABSTR"),
		("x=y.next","0010110",2,3,0,26),
		("ifx==null","0010111",2,31,27,"NOABSTR"),
		("x=y.next","0011000",1,2,1,28,"NOABSTR"),
		("ifx==y","0011001",1,3,29,30,"NOABSTR"),
		("x=y","0011010",3,2,25,"NOABSTR"),
		("exit","1111110","NOABSTR"), 
		("exit","0011111","NOABSTR")] 

	node_width=13
	pointer_num=4
	# descriptors number must be increased by 1
	desc_num=6
	next_num=2
	err_line="1111111"

	restrict_var=1
	
	env=(node_width,pointer_num,desc_num,next_num,err_line,restrict_var)
	return (program,env)

