#include "gta.h"
#include "../Mem/mem.h"
#include "gtastack.h"


void gtastack_init(gtastack *s,int size) {
	//s->val=(GTA **) mem_alloc(sizeof(GTA *)*(size));
	s->val=(GTA **) malloc(sizeof(GTA *)*(size));
	s->no=-1;
	s->size=size;
}

void gtastack_destroy(gtastack *s) {
	//mem_free(s->val);
	free(s->val);
}

GTA *gtastack_pop(gtastack *s) {
	if (s->no<0) return NULL;
	s->no--;
	return s->val[s->no+1];
}

int gtastack_push(gtastack *s,GTA *val) {
	/* realocate stack in case of reached limit */
	if (s->no>=s->size-1) {
		//s->val=(GTA **) mem_resize(s->val, sizeof(GTA *)*(s->size+50));
		s->val=(GTA **) realloc(s->val, sizeof(GTA *)*(s->size+50));
		s->size=s->size+50;
	}
	s->no++;
	s->val[s->no]=val;
	return 1;
}

int gtastack_empty(gtastack s) {
	if (s.no==-1) return 1;
	return 0;
}


