#define HSTACK_ALLOC_STEP 50

#include "gta.h"

typedef struct {
	int line;
	char order;
	GTA *state;
} hist_value; 


typedef struct {
	int no,size;
	hist_value *val;
} hist_stack;

void histstack_init(hist_stack *s,int size);

void histstack_destroy(hist_stack *s);

void histstack_reset(hist_stack *s);

hist_value histstack_pop(hist_stack *s);

void histstack_push(hist_stack *s,hist_value val);

int histstack_empty(hist_stack s);

