#define VPSTACK_ALLOC_STEP 50

#include "gta.h"

typedef struct {
	char *name;
	GTA *decr,*eq,*inc;
} var_pred; 


typedef struct {
	int no,size;
	var_pred *val;
} varpred_stack;

void varpredstack_init(varpred_stack *s,int size);

void varpredstack_destroy(varpred_stack *s);

void varpredstack_reset(varpred_stack *s);

var_pred varpredstack_pop(varpred_stack *s);

void varpredstack_push(varpred_stack *s,var_pred val);

int varpredstack_empty(varpred_stack s);

