#define VSTACK_ALLOC_STEP 50

#include "gta.h"

typedef struct {
	int line_from;
	int line_to;
	GTA *var;
} variant; 


typedef struct {
	int no,size;
	variant *val;
} var_stack;

void varstack_init(var_stack *s,int size);

void varstack_destroy(var_stack *s);

void varstack_reset(var_stack *s);

variant varstack_pop(var_stack *s);

void varstack_push(var_stack *s,variant val);

int varstack_empty(var_stack s);

