# this is a script template, script run set_project_path.sh in the main folder first


#------------------------------------
# compile artmc executables
echo "Compiling ARTMC executables (there may be few warnings, but NO ERROR) ..."
export MONA
cd "$PROJECT_PATH/artmc-main"

sh compile-main2-force-fin-height.sh
sh compile-main2-force-neighbour.sh
sh compile-main2-force-predicates.sh
echo "... done"

#------------------------------------
echo "Compiling auxionary executables ..."
cd  "$PROJECT_PATH/generator_gta/generator_main/automata_operations"
sh compile_get_transd_source.sh  
sh compile_intersect.sh  
sh compile_invert.sh  
sh compile_project.sh  
sh compile_union.sh
echo "... done"

#-----------------------------------
# copy executables into bin folder
cd "$PROJECT_PATH/"
cp artmc-main/main2-* bin
