import functions
import sys

def copy_n_elements_check_x_if_y_set_mark_lowlevel(bdd,index,number,idx,x,xval,y,mark,ret_state,ret_state_2,nondet_idx,mode):
# mode: 0 - nothing is known
#	1 - y is 0
#	2 - y is 1
	if number:
		if number==x:
			if xval:
				bdd.append((idx,0,index+1))
				bdd.append((idx+1,0,index+2))
			else:
				bdd.append((idx,index+1,0))
				bdd.append((idx+1,index+2,0))
			index=index+2
			(bdd,index)=copy_n_elements_check_x_if_y_set_mark_lowlevel(bdd,index,number-1,idx+2,x,xval,y,mark,ret_state,ret_state_2,nondet_idx,mode)
		elif number==y: # function expected, that mark < y
			bdd.append((idx,index+1,-2)) 
			aux=index
			index=index+1
			bdd.append((idx+1,index+1,0))
			index=index+1
			(bdd,index)=copy_n_elements_check_x_if_y_set_mark_lowlevel(bdd,index,number-1,idx+2,x,xval,y,mark,ret_state,ret_state_2,nondet_idx,1)
			bdd[aux]=(bdd[aux][0],bdd[aux][1],index)
			bdd.append((idx+1,0,index+1))
			index=index+1
			(bdd,index)=copy_n_elements_check_x_if_y_set_mark_lowlevel(bdd,index,number-1,idx+2,x,xval,y,mark,ret_state,ret_state_2,nondet_idx,2)
		elif number==mark: # function expected, that mark < y
			if mode==1: # y is not in this node -> preserve value of mark
				bdd.append((idx,index+1,index+2))
				bdd.append((idx+1,index+3,0))
				bdd.append((idx+1,0,index+3))
				index=index+3
				(bdd,index)=copy_n_elements_check_x_if_y_set_mark_lowlevel(bdd,index,number-1,idx+2,x,xval,y,mark,ret_state,ret_state_2,nondet_idx,mode)
			elif mode==2: # y is set -> set mark to 1
				bdd.append((idx+1,0,index+1))
				index=index+1
				(bdd,index)=copy_n_elements_check_x_if_y_set_mark_lowlevel(bdd,index,number-1,idx+2,x,xval,y,mark,ret_state,ret_state_2,nondet_idx,mode)
			else: error_msg_expl("Bad order on arguments - expected mark<y")
		else: # just copy
			bdd.append((idx,index+1,index+2))
			bdd.append((idx+1,index+3,0))
			bdd.append((idx+1,0,index+3))
			index=index+3
			(bdd,index)=copy_n_elements_check_x_if_y_set_mark_lowlevel(bdd,index,number-1,idx+2,x,xval,y,mark,ret_state,ret_state_2,nondet_idx,mode)
	else: # number has reached 0 -- we are finished: add nondeterministich choice of the next state
		if ret_state_2==-1: # no nondeterminism
			bdd.append((-1,ret_state,0))
			index=index+1
		else: #nondeterministich choice
			bdd.append((nondet_idx,index+1,index+2))
			bdd.append((-1,ret_state,0))
			bdd.append((-1,ret_state_2,0))
			index=index+3
	return (bdd,index)

#---------------------------------------------------------------------------

def copy_n_elements_check_x_if_y_set_mark(bdd,index,number,first_idx,x,xval,y,mark,ret_state,ret_state2,nondet_idx):
	if x==y: error_msg_expl("Expected x!=y")
	if x==mark: error_msg_expl("Expected x!=mark")
	if x>=mark: error_msg_expl("Expected x<mark")
	return copy_n_elements_check_x_if_y_set_mark_lowlevel(bdd,index,number,first_idx,number-x,xval,number-y,number-mark,ret_state,ret_state2,nondet_idx,0)

#---------------------------------------------------------------------------

def set_descriptor(bdd,index,length,first_idx,descr_no):
	for i in range(length):
		if (i==descr_no)or(i==0):bdd.append(((i*2)+first_idx+1,0,index+1))
		else: bdd.append(((i*2)+first_idx+1,index+1,0))
		index=index+1
	return (bdd,index)


def xnext_assign_y(node_width, pointer_num,desc_num, x, y, descr_order, descr_no,line_orig,line_goto):

# We use the following states in the transducer:
#   0 - reading the init symbols
#   1 - normal processing of the main tree structure
#   2 - Read null pointers
#   3 - Read undefined pointers
#   4 - Accept (everythig read properly)
#   5 - Reject state (malformed, not the right line number, etc.) 
#   6 - null pointer exception
#   7 - undef / null pointer exception
#   8 - We guess, that next pointer descriptor have to be changed to given descriptor
#   9 - pointer descriptor was set
#   10,11,... - trace from set pointer descriptor to memory node (this node must contains x)


# These are the codes of the types of the tree nodes (the first two bits, for transducers four bits: 1.in,1.out,2.in,2.out)
#   00 - an empty node (in bottom) / null pointers (in top) / undef pointers (in top) - see data structure description
#   01 - a pointer descriptor
#   10 - a memory node
#   11 - a top memory node (above which there are only other top nodes and then the null & undef. pointers and the line number)

	table=[] # The main transition table States x States --> BDD nodes
	bdd=[]   # Further looking up of the next state for the given situation.
                 # The triple is (the bit of input, the next BDD node for 0, the next BDD node for 1).
		 # (-1,x,_) then means that the target state has been found and it's x.

	# count track for a nondeterministich choice of the next state
	nondet_track=(node_width*2)


	#****************************************
	# bdd node 0 = a reject state
	#****************************************
	bdd.append((-1,5,0))#0
	index=1

       	#****************************************
	# left state=0, right state=0: 
	#   - empty nodes (00) till the first pointer description
	#   - the first pointer descriptor (01)
	#****************************************
	table.append((0,0,1))
	bdd.append((0,2,0))#1 -- the first bit of the type of the input node
	bdd.append((1,3,0))#2 -- the first bit of the type of the output node
	bdd.append((2,4,8))#3 -- if 1, we found the 1st pointer descriptor => go to line 8
	bdd.append((3,5,0))#4
	index=index+4
	bdd.append((nondet_track,index+1,index+2))
	bdd.append((-1,0,0))
	bdd.append((-1,8,0)) # we guess, that next pointer descriptor have to be changed to the given one
	index=index+3
	# a pointer descriptor (01)
	bdd.append((3,0,index+1))#6
	index=index+1
	descr_bdd=index # in the below case a pointer descriptor being read, we continue from here
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,1,0))
	index=index+1

	#****************************************
	#   - a memory node / a top memory node (1x)
	#   - a pointer descriptor (01)
	#   - a description of null pointers (00)
	#****************************************
	table.append((1,1,index))	
	table.append((0,1,index))
	table.append((1,0,index))
	bdd.append((0,index+1,index+4)) # pointer descriptor / memory node
	bdd.append((1,index+2,0))
	bdd.append((2,-2,index+3)) 
	aux=index+2
	bdd.append((3,0,descr_bdd)) # goto processing of a pointer descriptor
	index=index+4
	# a memory node or a top memory node
	(bdd,index)=copy_n_elements_check_x_if_y_set_mark(bdd,index,node_width-1,2,x+1,0,y+1,pointer_num+1+descr_no,1,8,nondet_track)
	# null pointers
	# If x==null -> null pointer exception
	# If y==null -> reject this tree (this case will be solved by another transducer)
	bdd[aux]=(bdd[aux][0],index,bdd[aux][2])
	bdd.append((3,index+1,0))
	index=index+1
	if x<y: aux1=x; aux2=y
	elif y<x: aux1=y; aux2=x
	else: functions.error_msg_expl("x_next_assign_y: x==y is forbiden combinations")
	(bdd,index,id_ok,id_except)=functions.copy_n_elements_and_remember_x(bdd,index,aux1+1,4,aux1)
	for i in id_except: # null pointer exception of x / y==null (will be solved by another transducer)
		if i[1]==1: bdd[i[0]]=(bdd[i[0]][0],index,bdd[i[0]][2])
		else: bdd[i[0]]=(bdd[i[0]][0],bdd[i[0]][1],index)
	if aux1==x: #case aux1==y is solved directly in previous for loop
		(bdd,index)=functions.copy_n_elements(bdd,index,(node_width-2)-aux1-1,((aux1+1)*2)+4)
		bdd.append((-1,6,0)) 
		index=index+1
	else:
		bdd.append((-1,5,0)) # This is a reject state
		index=index+1
	for i in id_ok:
		if i[1]==1: bdd[i[0]]=(bdd[i[0]][0],index,bdd[i[0]][2])
		else: bdd[i[0]]=(bdd[i[0]][0],bdd[i[0]][1],index)
	(bdd,index,id_ok,id_except)=functions.copy_n_elements_and_remember_x(bdd,index,(node_width-2)-aux1-1,((aux1+1)*2)+4,aux2-(aux1+1))
	for i in id_except: 
		if i[1]==1: bdd[i[0]]=(bdd[i[0]][0],index,bdd[i[0]][2])
		else: bdd[i[0]]=(bdd[i[0]][0],bdd[i[0]][1],index)
	if aux2==x: bdd.append((-1,6,0))
	else: bdd.append((-1,5,0)) # This is a reject state
	index=index+1
	for i in id_ok: # OK x!=null && y!=null
		if i[1]==1: bdd[i[0]]=(bdd[i[0]][0],index,bdd[i[0]][2])
		else: bdd[i[0]]=(bdd[i[0]][0],bdd[i[0]][1],index)
	bdd.append((-1,2,0)) 
	index=index+1

	#****************************************
	#   - we guess, that this node is searched descriptor
	#****************************************
	table.append((8,1,index))	
	table.append((8,0,index))
	bdd.append((0,index+1,0)) # It have to be pointer descriptor
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3)) 
	bdd.append((3,0,index+4))
	index=index+4
	(bdd,index)= set_descriptor(bdd,index,desc_num,4,descr_no)
	# NOW copy the rest of the pointer descriptor node up to the node_width
	# This is usefull only in case of enabled variance analysis on descriptors
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-(desc_num+2),4+(desc_num*2))
	bdd.append((-1,9,0))
	index=index+1

	#*********************************************
	# Trace of pointer descriptor
	# if descr_order==0 -> no trace
	#*********************************************
	for i in range(descr_order):
		table.append((0,9+i,index))
		table.append((1,9+i,index))
		bdd.append((0,index+1,0))
		bdd.append((1,index+2,0))
		bdd.append((2,0,index+3)) 
		bdd.append((3,0,index+4))
		index=index+4
		(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
		bdd.append((-1,10+i,0))
		index=index+1
	table.append((9+descr_order,0,index))
	table.append((9+descr_order,1,index))
	bdd.append((0,0,index+1)) #check for memory node (1x)
	bdd.append((1,0,index+2))
	index=index+2
	# -1 at the end of the command means no nondeterministich choice of next state
	(bdd,index)=copy_n_elements_check_x_if_y_set_mark(bdd,index,node_width-1,2,x+1,1,y+1,pointer_num+1+descr_no,1,-1,-1)
#def copy_n_elements_check_x_if_y_set_mark(bdd,index,number,first_idx,x,xval,y,mark,ret_state,ret_state2,nondet_idx):

	#----------------------------------------
	#  - undefined pointers
	#    Here, we are going to check, if x, and y are undefined, of not.
	# If on of them is undefined -> null pointer exception is raised (return state XXXXX)
	# Otherwise, return state 3 is given
	#---------------------------------------
	table.append((2,0,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,index+3,0)) 
	bdd.append((3,index+4,0))
	index=index+4
	if x<y: aux1=x; aux2=y
	elif y<x: aux1=y; aux2=x
	else: functions.error_msg_expl("x_next_assign_y: x==y is forbiden combinations")
	(bdd,index,id_ok,id_except)=functions.copy_n_elements_and_remember_x(bdd,index,aux1+1,4,aux1)
	for i in id_except: # undef pointer exception
		if i[1]==1: bdd[i[0]]=(bdd[i[0]][0],index,bdd[i[0]][2])
		else: bdd[i[0]]=(bdd[i[0]][0],bdd[i[0]][1],index)
	(bdd,index)=functions.copy_n_elements(bdd,index,(node_width-2)-aux1-1,((aux1+1)*2)+4)
	bdd.append((-1,7,0)) 
	index=index+1
	for i in id_ok: 
		if i[1]==1: bdd[i[0]]=(bdd[i[0]][0],index,bdd[i[0]][2])
		else: bdd[i[0]]=(bdd[i[0]][0],bdd[i[0]][1],index)
	(bdd,index,id_ok,id_except)=functions.copy_n_elements_and_remember_x(bdd,index,(node_width-2)-aux1-1,((aux1+1)*2)+4,aux2-(aux1+1))
	for i in id_except: # undef pointer exception
		if i[1]==1: bdd[i[0]]=(bdd[i[0]][0],index,bdd[i[0]][2])
		else: bdd[i[0]]=(bdd[i[0]][0],bdd[i[0]][1],index)
	bdd.append((-1,7,0))
	index=index+1
	for i in id_ok:
		if i[1]==1: bdd[i[0]]=(bdd[i[0]][0],index,bdd[i[0]][2])
		else: bdd[i[0]]=(bdd[i[0]][0],bdd[i[0]][1],index)
	bdd.append((-1,3,0)) 
	index=index+1

	# ****************************************
	# left state=6, right state=0:
	#  - null pointer exception - read of undef pointers
	# ****************************************	
	table.append((6,0,index))	
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width,0)
	bdd.append((-1,7,0))
	index=index+1

	# ****************************************
	# left state=7, right state=0:
	#  - a line number change to undef/null pointer exception
	# ****************************************	
	table.append((7,0,index))	
	(bdd,index)=functions.change_line_num_to_err(bdd,index,line_orig)
	bdd.append((-1,4,0)) # accept
	index=index+1
	# ****************************************
	# left state=3, right state=0:
	#  - a line number change 
	# ****************************************	
	table.append((3,0,index))	
	(bdd,index)=functions.change_line_num(bdd,index,line_orig,line_goto)
	bdd.append((-1,4,0)) # accept
	index=index+1

	return(bdd,table)

#--------------------------------------------------------------------------------
#              T E S T S
#--------------------------------------------------------------------------------

def test_gen_x_next_assign_y():
	(bdd,table)=xnext_assign_y(9,4,3,1,1,1,"000","001")
	functions.gen_gta_file(bdd,table, [4],"xnext_assign_y.gta")


#test_gen_x_next_assign_y()


