/*
 * BddException.java
 */
package bdd;

/**
 * This is exception is thrown if it is impossible to construct a BDD.
 * 
 * @author Pierre Salagnac
 */
public class BddException extends Exception {

  /**
   * Create a new exception with the specified error message.
   * 
   * @param msg The error message.
   */
  public BddException(String msg) {
    
    super(msg) ;
    
  }
  
}
