package cril.calife.export.engine.averiles.ARTMC;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.nio.channels.FileChannel;

public class FileUtil {

	public static boolean copy(String file, String newname) {
		boolean result = false;
		FileChannel in = null;
		FileChannel out = null;
		try {
			in = new FileInputStream(file).getChannel();			
			out = new FileOutputStream(newname).getChannel();
			in.transferTo(0, in.size(), out);
			result = true;
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if(in != null) {
				try {
					in.close();
				} catch (IOException e) {}
			}
			if(out != null) {
				try {
					out.close();
				} catch (IOException e) {}
			}
		}
		return result;
	}

	public static String getFileContent(String file) {
		String content = "";
		try {
			BufferedReader in = new BufferedReader(new FileReader(file));
			String s = new String();
			while((s = in.readLine())!= null)
				content += s + "\n";
			in.close();
		} catch( IOException e ) {
			e.printStackTrace();
		}
		return content;
	}

}
