/*Copyright (C) 2002  Bertrand Tavernier (CRIL Technology)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/

package cril.calife.utils;

import javax.swing.filechooser.*;
import java.io.File;

public class FiltreDir extends FileFilter
{

	 private File fparent = null;

	 public FiltreDir(File fparent) {
	 	this.fparent=fparent;
	 }
	 public FiltreDir() {}
	 
   public boolean accept(File fichier) {
   if (!fichier.isDirectory())
   	return false;
   
   if (fparent==null)
   	return true;
   
   if (fichier.getParent().equals(fparent.getAbsolutePath())) // On accepte si le fichier est un repertoire
    return true;
    
   return false;
   }

   public String getDescription() {
   return "Rpertoire de travail";
   }
}
