# Deutsch-Schorr-Waite tree traversal

# pointer variables are : x=1, y=2, t=3
# next pointers are : left=0, right=1

# initially tree is pointed by x


def get_program():
	program=[("x=null","0000001",3,1,"NOABSTR"),
		("ifx==null","0000010",1,26,2,"NOABSTR"),
		("ifdata","0000011",1,"11",16,3),
		("ifdata","0000100",1,"01",10,4,"NOABSTR"),
		("x=y.next","0000101",2,1,1,5,"NOABSTR"),
		("ifx==null","0000110",2,6,7,"NOABSTR"),
		("setdata","0000111",1,"01",2,"NOABSTR"),
		("x.next=y","0001000",1,3,1,8,4,"NOABSTR"),
		("x=y","0001001",3,1,9,"NOABSTR"),
		("x=y","0001010",1,2,2,"NOABSTR"),
		("x=y.next","0001011",2,1,0,11,"NOABSTR"),
		("ifx==null","0001100",2,12,13,"NOABSTR"),
		("setdata","0001101",1,"11",2,"NOABSTR"),
		("x.next=y","0001110",1,3,0,14,5,"NOABSTR"),
		("x=y","0001111",3,1,15,"NOABSTR"),
		("x=y","0010000",1,2,2,"NOABSTR"),
		("x=y","0010001",2,1,17,"NOABSTR"),
		("x=y","0010010",1,3,18,"NOABSTR"),
		("ifx==null","0010011",1,26,19,"NOABSTR"),
		("ifdata","0010100",1,"00",20,23,"NOABSTR"),
		("x=y.next","0010101",3,1,1,21,"NOABSTR"),
		("x.next=y","0010110",1,2,1,22,6,"NOABSTR"),
		("setdata","0010111",1,"01",2,"NOABSTR"),
		("x=y.next","0011000",3,1,0,24,"NOABSTR"),
		("x.next=y","0011001",1,2,0,25,7,"NOABSTR"),
		("setdata","0011010",1,"11",2,"NOABSTR"),
		("exit","0011011","NOABSTR")]  
	#NOTE: datasize: 2 => nodewidth = datasize+pointer_num+descr_num
	node_width=16
	# pointer number must be increased by 1
	pointer_num=4
	# descriptors number must be increased by 1
	desc_num=8
	next_num=2
	err_line="1111111"

	restrict_var=1
	
	env=(node_width,pointer_num,desc_num,next_num,err_line,restrict_var)
	return (program,env)

