
typedef struct {
	int no,beg,end,size,*val;
} stack;

typedef struct {
	int no,beg,end,size;
	unsigned *val;
} Ustack;

/* functions for stack of INTs */

void stack_init(stack *s,int size);

void stack_destroy(stack *s);

int stack_pop(stack *s); 

int stack_push(stack *s,int val);

int stack_contains(stack s, int val);
	
int stack_empty(stack s);

/* equal functions for unsigned */

void Ustack_init(Ustack *s,int size);

void Ustack_destroy(Ustack *s);

unsigned Ustack_pop(Ustack *s);

int Ustack_push(Ustack *s,unsigned val);

int Ustack_contains(Ustack s, unsigned val);

int Ustack_empty(Ustack s);

