#this is a script template, use script set_project_path.sh first

if [ $[ $# < 4 ] == 1 ]; then
echo "USAGE: parse_c_code.t.sh c-file function_name handle_data ignore_array_assgn"
echo "handle_data: 1: YES, 0: NO (overapproximate)"
echo "ignore_array_assgn: 1: ignore (overapproximate), 0: stop parser when arrays are used"
exit
fi

# first parce .c input into clf file

echo "--------------------------------------"
echo "Parcing function $2 from $1"
echo "--------------------------------------"

$JRE_PATH -jar "$PROJECT_PATH/Averiles-C-parser/c2xml.jar" "$1" "$2";

if [ -f "$2_automaton.clf" ]; then
true
else
echo "---------------------------------"
echo "ERROR: file $2_automaton.clf not created by the parser..."
echo "... stoped"
exit
fi

echo "--------------------------------------"
echo ".c file parces."
echo "running clf -> ARTMC parcer"
echo "--------------------------------------"

#now we parse clf format into ARTMC inputs

if [ -f "typedefs" ]; then
true
else
echo "--------------------------------------"
echo "ERROR: provide typedefs to continue ..."
echo "... stoped"
exit
fi

DESC_NUM=`"$PROJECT_PATH/bin/get_typedef_descr.t.sh"`

$JRE_PATH -jar "$PROJECT_PATH/Averiles-C-parser/AverilesToARTMC_v5.jar" "$2_automaton.clf" "$3" "$4" "$DESC_NUM"

