#!/bin/sh
PROJECT_PATH=/homes/kazi/rogalew/Experiments/ARTMC-distr-2

#---------------------------------
# path to the JRE executable (java 1.5 or higher)
JRE_PATH=`which java`

#JRE_PATH="/local/jdk1.5.0_12/bin/java"
#JRE_PATH=/usr/bin/java5

# Project program (projection of mona tree automata)
PROJECT="$PROJECT_PATH/generator_gta/generator_main/automata_operations/project"
# Base directory
PARSER_HOME="$PROJECT_PATH/parser"

#----------------------------------
# The mona source code is necessary to build the executables from the source code
MONA="/homes/kazi/rogalew/Experiments/tools/mona-1.4"

#-----------------------------------------------
# path to the generator directory
GENERATOR_DIR="$PROJECT_PATH/generator_gta/"

export PATH="$PATH:$GENERATOR_DIR/generator_main/automata_operations/"
export PYTHONPATH=`pwd`

python "$GENERATOR_DIR/generator_main/generator_main.py"

