
# This function generate a GTA describing an empty set
def gen_empty(filename):
	out=[]
	out.append("MONA GTA\n")
	out.append("number of variables: 2\n")
	out.append("state spaces: 3\n")
	out.append("universes: 2\n")
	out.append("state space sizes: 1 1 1\n")
	# results of state space 0:
	# 0 - reject; 
	out.append("final: -1")
	out.append("\n")
	out.append("guide:\n")
	out.append(" <hat> 1 2\n")
	out.append(" <univ> 1 1\n")
	out.append(" <dummy> 2 2\n")
	out.append("types: 0\n")
	out.append("universes:\n")
	out.append(" <univ> 0\n")
	out.append(" <dummy> 1\n")
	out.append("variable orders and state spaces:\n")
	out.append(" P 2: 1\n")
	out.append(" Q 2: 1\n")

	
	out.append("\nstate space 0:\ninitial state: 0\n bdd nodes: 1\n behaviour:\n") 
	out.append("  0\n")
	out.append(" bdd:\n")
	out.append("  -1 0 0\n\n")

	out.append("\nstate space 1:\ninitial state: 0\n bdd nodes: 1\n behaviour:\n") 
	out.append("  0\n")
	out.append(" bdd:\n")
	out.append("  -1 0 0\n\n")

	out.append("\nstate space 2:\ninitial state: 0\n bdd nodes: 1\n behaviour:\n") 
	out.append("  0\n")
	out.append(" bdd:\n")
	out.append("  -1 0 0\n\n")

	out.append("end\n")

	# everything is generated -> we write the file
	file=open(filename,"w")
	file.writelines(out)
	file.close()

