/*
 * NullPath.java
 */
package parser;


/**
 * This path allows a pointed to be null.
 * 
 * @author Pierre Salagnac
 */
public class NullPath extends Path {

  
  /**
   * Create a new instance.
   */
  public NullPath() {
    
  }
  
  
  /**
   * Clone this path.
   * 
   * @return A new instance of NullPath.
   */
  @Override
  public NullPath clone() {
    
    return new NullPath() ;
    
  }
  
}
