/* Copyright (C) 2004  Bertrand Tavernier (CRIL Technology)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/

package cril.calife.export.typechecker;

import java.util.ArrayList;
import java.util.Hashtable;

import org.w3c.dom.Element;



/*
 * Created on 12 aot 2004 by bertrand.tavernier
 *
 */

/**
 * @author bertrand.tavernier
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TypeSystem {
    private Hashtable ht_fun = new Hashtable();
    private ArrayList fun = new ArrayList();
    private ArrayList cast = new ArrayList();
    private ArrayList csttype = new ArrayList();
    private ArrayList param = new ArrayList();
    private ArrayList var = new ArrayList();
    
    public void addVariable(Element ecs) {
        var.add(ecs);
    }

    public void addParameter(Element ecs) {
        param.add(ecs);
    }
    
    public void addConstType(Element ecs) {
        csttype.add(ecs);
    }
    
    public void addFunction(Element eFun) {
        ht_fun.put(eFun.getAttribute("Label"),eFun);
        fun.add(eFun);
    }
    
    public void addCast(Element eCast) {
        cast.add(eCast);
    }
    
    public ArrayList getTerms() {
        ArrayList res = new ArrayList();
        res.addAll(var);
        res.addAll(param);
        res.addAll(csttype);
        return res;
    }
    public ArrayList getFunctions() { return fun; }
    public ArrayList getCasts() { return cast; }
    public ArrayList getConstTypes() { return csttype; }
    
    public Element getFunction(String label) {
        return (Element) ht_fun.get(label);
    }
    
}
