/* Copyright (C) 2003  Bertrand Tavernier (CRIL Technology)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/

package cril.calife.utils;

import java.util.ArrayList;
import org.w3c.dom.*;

/**
 * @author bertrand.tavernier
 * 7 mai 2003
 */
public class ContextParser {
	
	public static ArrayList getVarTypes(Document DOM) {
		ArrayList v_tmp = DOMUtil.copyNodeList(DOM.getElementsByTagName("VarType"));
		ArrayList result = new ArrayList();
		for (int it=0;it<v_tmp.size();it++) {
			result.add(DOMUtil.NtoE((Node)v_tmp.get(it)).getAttribute("Label"));
		}
		return result;
	}
	
	public static ArrayList getParamTypes(Document DOM) {
		ArrayList v_tmp = DOMUtil.copyNodeList(DOM.getElementsByTagName("ParamType"));
		ArrayList result = new ArrayList();
		for (int it=0;it<v_tmp.size();it++) {
			result.add(DOMUtil.NtoE((Node)v_tmp.get(it)).getAttribute("Label"));
		}
		return result;
	}

}
